## primecount 7.2+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4...3.19)
project(primecount CXX)
set(PRIMECOUNT_VERSION_MAJOR 7)
set(PRIMECOUNT_VERSION_MINOR 2)
set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")

# Build options ######################################################

option(BUILD_PRIMECOUNT    "Build the primecount binary"           ON)
option(BUILD_LIBPRIMESIEVE "Build libprimesieve"                   ON)
option(BUILD_SHARED_LIBS   "Build the shared libprimecount"        OFF)
option(BUILD_STATIC_LIBS   "Build the static libprimecount"        ON)
option(BUILD_MANPAGE       "Regenerate man page using a2x program" OFF)
option(BUILD_TESTS         "Build the test programs"               OFF)

option(WITH_POPCNT          "Use the POPCNT instruction"            ON)
option(WITH_LIBDIVIDE       "Use libdivide.h"                       ON)
option(WITH_OPENMP          "Enable OpenMP multi-threading"         ON)
option(WITH_DIV32           "Use 32-bit division instead of 64-bit division whenever possible" ON)
option(WITH_MSVC_CRT_STATIC "Link primecount.lib with /MT instead of the default /MD" OFF)
option(WITH_FLOAT128        "Use __float128 (requires libquadmath)" OFF)
option(WITH_JEMALLOC        "Use jemalloc allocator"                OFF)

# libprimecount sanity checks ########################################

# We don't yet support building libprimecount as a shared DLL
# library on Windows. If you need this let me know...
if(WIN32)
    set(BUILD_SHARED_LIBS OFF)
endif()

if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON")
endif()

# Set default build type to Release ##################################

if(NOT CMAKE_VERSION VERSION_LESS 3.9)
    get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
    set(isMultiConfig TRUE)
endif()

if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# primecount binary source files #####################################

set(BIN_SRC src/app/cmdoptions.cpp
            src/app/main.cpp
            src/app/help.cpp
            src/app/test.cpp)

# primecount library source files ####################################

set(LIB_SRC src/api.cpp
            src/api_c.cpp
            src/BitSieve240.cpp
            src/FactorTable.cpp
            src/RiemannR.cpp
            src/P2.cpp
            src/P3.cpp
            src/PhiTiny.cpp
            src/PiTable.cpp
            src/S1.cpp
            src/Sieve.cpp
            src/LoadBalancerP2.cpp
            src/LoadBalancerS2.cpp
            src/StatusS2.cpp
            src/generate.cpp
            src/nth_prime.cpp
            src/phi.cpp
            src/pi_legendre.cpp
            src/pi_lehmer.cpp
            src/pi_meissel.cpp
            src/pi_primesieve.cpp
            src/print.cpp
            src/util.cpp
            src/lmo/pi_lmo1.cpp
            src/lmo/pi_lmo2.cpp
            src/lmo/pi_lmo3.cpp
            src/lmo/pi_lmo4.cpp
            src/lmo/pi_lmo5.cpp
            src/lmo/pi_lmo_parallel.cpp
            src/deleglise-rivat/S2_hard.cpp
            src/deleglise-rivat/S2_trivial.cpp
            src/deleglise-rivat/pi_deleglise_rivat.cpp
            src/gourdon/pi_gourdon.cpp
            src/gourdon/Phi0.cpp
            src/gourdon/B.cpp
            src/gourdon/D.cpp
            src/gourdon/LoadBalancerAC.cpp
            src/gourdon/SegmentedPiTable.cpp
            src/gourdon/Sigma.cpp)

# Required includes ##################################################

include(GNUInstallDirs)
include(CheckCXXCompilerFlag)
include(CMakePushCheckState)

# Use 32-bit integer division ########################################

# Check at runtime if the dividend and divisor are < 2^32 and
# if so use 32-bit integer division instead of 64-bit integer
# division. On most CPUs before 2020 this significantly
# improves performance.
if(WITH_DIV32)
    set(ENABLE_DIV32 "ENABLE_DIV32")
endif()

# Check if libdivide.h compiles ######################################

if(WITH_LIBDIVIDE)
    cmake_push_check_state()
    set(CMAKE_REQUIRED_INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/include")

    check_cxx_source_compiles("
        #include <libdivide.h>
        #include <stdint.h>
        int main() {
            libdivide::divider<uint64_t, libdivide::BRANCHFREE> d(3);
            uint64_t n = 1000000000;
            return (n / d == n / 3) ? 0 : 1;
        }" libdivide_branchfree)

    cmake_pop_check_state()
endif()

if(WITH_LIBDIVIDE AND libdivide_branchfree)
    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy_libdivide.cpp)
    set(LIB_SRC ${LIB_SRC} src/gourdon/AC_libdivide.cpp)
else()
    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy.cpp)
    set(LIB_SRC ${LIB_SRC} src/gourdon/AC.cpp)
endif()

# Enable __float128 support (requires libquadmath) ###################

if(WITH_FLOAT128)
    set(LIB_QUADMATH "quadmath")
    set_source_files_properties(src/RiemannR.cpp PROPERTIES COMPILE_DEFINITIONS HAVE_FLOAT128)
endif()

# Check for OpenMP ###################################################

if(WITH_OPENMP)
    find_package(OpenMP QUIET)

    if(OpenMP_FOUND OR OpenMP_CXX_FOUND)
        cmake_push_check_state()
        set(CMAKE_REQUIRED_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX11_STANDARD_COMPILE_OPTION}")
        set(CMAKE_REQUIRED_INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/include")

        check_cxx_source_compiles("
            #include <int128_t.hpp>
            int main() {
                primecount::maxint_t sum = 0;
                #pragma omp parallel for reduction(+: sum)
                for (int i = 0; i < 100; i++)
                    sum += i;
                return 0;
            }" OpenMP)

        if(NOT OpenMP)
            find_library(LIB_ATOMIC NAMES atomic libatomic.so.1)

            if(NOT LIB_ATOMIC)
                set(LIB_ATOMIC "")
            else()
                set(CMAKE_REQUIRED_LIBRARIES "${LIB_ATOMIC}")

                check_cxx_source_compiles("
                    #include <int128_t.hpp>
                    int main() {
                        primecount::maxint_t sum = 0;
                        #pragma omp parallel for reduction(+: sum)
                        for (int i = 0; i < 100; i++)
                            sum += i;
                        return 0;
                    }" OpenMP_with_libatomic)

                if(NOT OpenMP_with_libatomic)
                    set(LIB_ATOMIC "")
                endif()
            endif()
        endif()

        cmake_pop_check_state()

        # We made sure OpenMP works. In 2021 OpenMP
        # does e.g. not work using Apple Clang.
        if(OpenMP OR OpenMP_with_libatomic)
            if(TARGET OpenMP::OpenMP_CXX)
                set(LIB_OPENMP "OpenMP::OpenMP_CXX")
            else()
                set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
            endif()

            # Create list of OpenMP libs for pkg-config/pkgconf
            foreach(X IN LISTS OpenMP_CXX_LIB_NAMES)
                string(APPEND PKGCONFIG_LIBS_OPENMP "-l${X} ")
            endforeach()
        endif()
    else()
        message(STATUS "Performing Test OpenMP")
        message(STATUS "Performing Test OpenMP - Failed")
    endif()
endif()

# Find POPCNT compiler flag ##########################################

if(WITH_POPCNT)
    cmake_push_check_state()
    set(CMAKE_REQUIRED_FLAGS -Werror)
    check_cxx_compiler_flag(-mpopcnt mpopcnt)
    cmake_pop_check_state()

    if(mpopcnt)
        set(POPCNT_FLAG "-mpopcnt")
    endif()
else()
    # On the x86/x64 CPU architectures WITH_POPCNT=OFF disables the
    # POPCNT instruction and instead uses a portable integer popcount
    # algorithm. This deteriorates performance by up to 50%.
    # Disabling POPCNT on x86/x64 is necessary for old CPUs from
    # before 2008. On other CPU architectures POPCNT is always used
    # if it is available as this generally does not cause any issues.
    # Hence WITH_POPCNT=OFF is ignored on non x86/x64 CPUs.

    check_cxx_source_compiles("
        int main() {
            #if defined(_MSC_VER) && (defined(_M_IX86) || defined(_M_X64))
                return 0;
            #else
                Error: not MSVC compiler
            #endif
        }" MSVC_x86_or_x64)

    # We only need to disable POPCNT for MSVC on x86/x64.
    # For GCC/Clang __builtin_popcountll() will automatically
    # be portable if we compile without the -mpopcnt flag.
    if(MSVC_x86_or_x64)
        set(DISABLE_POPCNT "DISABLE_POPCNT")
    endif()
endif()

# libprimesieve ######################################################

# By default the libprimesieve dependency is built from source
# (BUILD_LIBPRIMESIEVE=ON). However when packaging primecount
# for e.g. a Linux distro this is not a good idea. For this use
# case it is better to install the libprimesieve package
# (e.g. libprimesieve-dev) and link against that version.

if(BUILD_LIBPRIMESIEVE)
    set(COPY_BUILD_MANPAGE "${BUILD_MANPAGE}")
    set(COPY_BUILD_TESTS "${BUILD_TESTS}")
    set(BUILD_MANPAGE OFF CACHE BOOL "Build primesieve manpage" FORCE)
    set(BUILD_TESTS OFF CACHE BOOL "Build primesieve tests" FORCE)
    option(BUILD_PRIMESIEVE "Build primesieve binary" OFF)

    add_subdirectory(lib/primesieve)

    set(BUILD_MANPAGE "${COPY_BUILD_MANPAGE}" CACHE BOOL "Regenerate man page using a2x" FORCE)
    set(BUILD_TESTS "${COPY_BUILD_TESTS}" CACHE BOOL "Build test programs" FORCE)
else()
    find_package(primesieve REQUIRED)
endif()

# Testing ############################################################

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

# libprimecount ######################################################

if(BUILD_SHARED_LIBS)
    add_library(libprimecount SHARED ${LIB_SRC})
    set_target_properties(libprimecount PROPERTIES OUTPUT_NAME primecount)
    set_target_properties(libprimecount PROPERTIES SOVERSION ${PRIMECOUNT_VERSION_MAJOR})
    set_target_properties(libprimecount PROPERTIES VERSION ${PRIMECOUNT_VERSION})
    target_compile_definitions(libprimecount PRIVATE "${DISABLE_POPCNT}" "${ENABLE_DIV32}")
    target_compile_options(libprimecount PRIVATE "${POPCNT_FLAG}")
    target_link_libraries(libprimecount PRIVATE primesieve::primesieve "${LIB_OPENMP}" "${LIB_QUADMATH}" "${LIB_ATOMIC}")

    target_compile_features(libprimecount
    PRIVATE
        cxx_constexpr
        cxx_lambdas
        cxx_range_for)

    target_include_directories(libprimecount PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimecount
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# libprimecount-static ###############################################

if(BUILD_STATIC_LIBS)
    add_library(libprimecount-static STATIC ${LIB_SRC})
    set_target_properties(libprimecount-static PROPERTIES OUTPUT_NAME primecount)
    target_compile_definitions(libprimecount-static PRIVATE "${DISABLE_POPCNT}" "${ENABLE_DIV32}")
    target_compile_options(libprimecount-static PRIVATE "${POPCNT_FLAG}")
    target_link_libraries(libprimecount-static PRIVATE primesieve::primesieve "${LIB_OPENMP}" "${LIB_QUADMATH}" "${LIB_ATOMIC}")

    if(WITH_MSVC_CRT_STATIC)
        set_target_properties(libprimecount-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
    endif()

    if(NOT BUILD_SHARED_LIBS)
        # make sure libprimecount is always defined
        add_library(libprimecount ALIAS libprimecount-static)
    endif()

    target_compile_features(libprimecount-static
    PRIVATE
        cxx_constexpr
        cxx_lambdas
        cxx_range_for)

=== test/CMakeLists.txt ===
file(GLOB files "*.cpp")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_compile_definitions(${binary_name} PRIVATE "${ENABLE_POPCNT}" "${ENABLE_DIV32}")
    target_link_libraries(${binary_name} libprimecount primesieve::primesieve "${LIB_OPENMP}" "${LIB_ATOMIC}")
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

=== debian/changelog ===
primecount (7.2+ds-6) unstable; urgency=medium

  * Debianization:
    - d/patches/*:
      - d/p/upstream-cmake-enhance.patch, introduce;
    - d/rules:
      - override_dh_auto_install-indep target, stable machinery.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 13 Feb 2022 22:05:43 +0000

primecount (7.2+ds-5) unstable; urgency=medium

  * Team Upload.
  * d/rules: Fix build on arch-indep package
  * Add d/salsa-ci.yml

 -- Nilesh Patra <nilesh@debian.org>  Mon, 14 Feb 2022 00:44:45 +0530

primecount (7.2+ds-4) unstable; urgency=medium

  * Technical upload.
  * Debianization:
    - d/control:
      - primecount-doc package:
        - Suggests field, remove pdf-viewer.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 13 Feb 2022 17:23:33 +0000

primecount (7.2+ds-3) unstable; urgency=medium

  * Debianization:
    - d/copyright, address libdivide.h copyrights.

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 09 Feb 2022 19:57:27 +0000

primecount (7.2+ds-2) unstable; urgency=medium

  * FTBFS fix: add libprimesieve-dev to Build-Depends.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 31 Jan 2022 10:43:53 +0000

primecount (7.2+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1003317)

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 30 Jan 2022 20:14:52 +0000

=== debian/control ===
Source: primecount
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>
Section: math
Priority: optional
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (=13),
 cmake,
 libprimesieve-dev,
 asciidoc-base, xmlto
Build-Depends-Indep:
	pandoc
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/math-team/primecount.git
Vcs-Browser: https://salsa.debian.org/math-team/primecount
Homepage: https://github.com/kimwalisch/primecount

Package: primecount
Architecture: all
Multi-Arch: foreign
Depends: primecount-bin, ${misc:Depends}
Description: fast prime number counter C/C++ library
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This dummy package provides the standard installation.

Package: libprimecount7
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: primecount-bin (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libprimecount
Provides: libprimecount
Description: fast prime number counter C/C++ library -- lib
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the shared library.

Package: libprimecount-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libprimecount7 (= ${binary:Version}), libprimecount-dev-common (= ${source:Version}),
 libprimesieve-dev,
 ${misc:Depends}
Suggests: primecount-doc (= ${source:Version}), pkg-config
Conflicts: libprimecount-dev
Provides: libprimecount-dev
Description: fast prime number counter C/C++ library -- libdev
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the static library and symbolic links needed
 for development.

Package: libprimecount-dev-common
Architecture: all
Multi-Arch: foreign
Replaces: libprimecount7-dev-common
Breaks: libprimecount7-dev-common
Section: libdevel
Depends: ${misc:Depends}
Recommends: libprimecount-dev (= ${binary:Version})
Provides: libprimecount-dev-common
Description: fast prime number counter C/C++ library -- headers
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the headers needed by developers.

Package: primecount-bin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: primecount-doc (= ${source:Version})
Description: fast prime number counter C/C++ library -- bin
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 This package provides the command line utility primecount.

Package: primecount-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: www-browser
Enhances: primecount-bin (= ${binary:Version}), libprimecount-dev (= ${binary:Version})
Description: fast prime number counter C/C++ library -- doc
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the API documentation with its concomitant examples.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

## inspired from mpfr material
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS    += -O0
	CXXCFLAGS += -O0
else ifeq ($(DEB_HOST_ARCH),alpha)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else ifeq ($(DEB_HOST_ARCH),sha4)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else
	CFLAGS   := $(subst -O2,-O3,$(CFLAGS))
	CXXFLAGS := $(subst -O2,-O3,$(CXXFLAGS))
endif

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@ --builddirectory=_BUILD

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_LIBPRIMESIEVE=OFF \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_STATIC_LIBS=ON \
		-DBUILD_TESTS=ON \
		-DBUILD_MANPAGE=ON

override_dh_auto_build-indep: README.toc.md
	$(MAKE) -f debian/adhoc/Makefile doc

override_dh_auto_test-indep:
	true

override_dh_auto_install-indep:
	DESTDIR=$(CURDIR)/debian/tmp $(CMAKE) \
			-DCMAKE_INSTALL_COMPONENT=libprimecount-headers \
		-P _BUILD/cmake_install.cmake

override_dh_prep-arch: README.toc.md

override_dh_installdocs:
	dh_installdocs -pprimecount-bin    --link-doc=libprimecount7
	dh_installdocs -plibprimecount-dev --doc-main-package=libprimecount-dev-common
	dh_installdocs --remaining-packages

override_dh_compress-indep:
	dh_compress -X.pdf -X.md -Xexamples

override_dh_missing:
	dh_missing --list-missing

README.toc.md:
	sed \
			-e '/\[libprimecount/d' \
			-e '/\[primecount-backup/d' \
			-e '/\[BUILD/d' \
			-e '/\[RELEASE/d' \
		doc/README.md > README.toc.md

CMAKE ?= cmake

=== debian/tests/control ===
Test-command: primecount --test

Tests: make-check-bin
Depends: primecount-bin

Tests: make-check-dev
Depends: libprimecount-dev, build-essential, pkg-config
Restrictions: allow-stderr

Tests: build-examples
Depends: primecount-doc, libprimecount-dev, build-essential, pkg-config

=== debian/watch ===
version=4
opts=repack,repacksuffix=+ds,compression=xz,dversionmangle=s/\+ds//,uversionmangle=s/-rc/~rc/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/primecount-$1\.tar\.gz/ \
https://github.com/kimwalisch/primecount/releases .*/archive/refs/tags/v?(\d\S*)\.tar\.gz

## primecount 7.4+ds

=== debian/changelog ===
primecount (7.4+ds-1) unstable; urgency=medium

  * New usptream minor release.
  * Debianization:
    - d/control:
      - Standards-Version, bump to 4.6.1 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 10 Jul 2022 13:06:39 +0000

primecount (7.3+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/rules:
      - override_dh_auto_configure target, now build without POPCNT support;
    - d/patches/*:
      - d/p/upstream-cmake-enhance.patch, integrated;
     - lintin privacy-breach fix:
    	- d/adhoc/lintian/privacy-breach/www/images/*.svg, introduce
      - d/p/debianization-documentation.patch, introduce;
      - d/primecount-doc.links, introduce;
     	- d/{copyright,primecount-doc.docs} update.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 08 May 2022 14:22:52 +0000

## primecount 7.6%2Bds

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,11 @@
 Build-Depends:
  debhelper-compat (=13),
  cmake,
- libprimesieve-dev,
+ libprimesieve-dev (>=8.0),
  asciidoc-base, xmlto
 Build-Depends-Indep:
 	pandoc
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/math-team/primecount.git
 Vcs-Browser: https://salsa.debian.org/math-team/primecount
 Homepage: https://github.com/kimwalisch/primecount

## primecount 7.6+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4...3.22)
project(primecount CXX)
set(PRIMECOUNT_VERSION_MAJOR 7)
set(PRIMECOUNT_VERSION_MINOR 6)
set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")

# Build options ######################################################

option(BUILD_PRIMECOUNT    "Build the primecount binary"           ON)
option(BUILD_LIBPRIMESIEVE "Build libprimesieve"                   ON)
option(BUILD_SHARED_LIBS   "Build the shared libprimecount"        OFF)
option(BUILD_STATIC_LIBS   "Build the static libprimecount"        ON)
option(BUILD_MANPAGE       "Regenerate man page using a2x program" OFF)
option(BUILD_TESTS         "Build the test programs"               OFF)

option(WITH_POPCNT          "Use the POPCNT instruction"            ON)
option(WITH_LIBDIVIDE       "Use libdivide.h"                       ON)
option(WITH_OPENMP          "Enable OpenMP multi-threading"         ON)
option(WITH_MSVC_CRT_STATIC "Link primecount.lib with /MT instead of the default /MD" OFF)
option(WITH_FLOAT128        "Use __float128 (requires libquadmath)" OFF)
option(WITH_JEMALLOC        "Use jemalloc allocator"                OFF)

# When using WITH_DIV32=ON primecount checks at runtime
# if 32-bit division can be used instead of 64-bit
# division which improves performance on old x64 CPUs
# (<= 2020). However Clang performs this optimization by
# itself, so we can disable WITH_DIV32.
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "LLVM")
    option(WITH_DIV32 "Use 32-bit division instead of 64-bit division whenever possible" OFF)
else()
    option(WITH_DIV32 "Use 32-bit division instead of 64-bit division whenever possible" ON)
endif()

# Option sanity checks ###############################################

# We don't yet support building libprimecount as a shared DLL
# library on Windows. If you need this let me know...
if(WIN32)
    set(BUILD_SHARED_LIBS OFF)
endif()

if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON!")
endif()

if(STATICALLY_LINK_LIBPRIMECOUNT AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "Using STATICALLY_LINK_LIBPRIMECOUNT=ON requires BUILD_STATIC_LIBS=ON!")
endif()

# Static vs. shared linking ##########################################

# By default libprimecount is linked statically if only the static
# libprimecount has been built. If libprimecount has been built as
# both a static and shared library then the shared libprimecount will
# be used for linking.

# It is possible to force static linking by setting:
# cmake -DSTATICALLY_LINK_LIBPRIMECOUNT=ON
# This way libprimecount will be linked statically even if
# libprimecount has been built as both a static and shared library.

if(NOT STATICALLY_LINK_LIBPRIMECOUNT)
    if(BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)
        set(STATICALLY_LINK_LIBPRIMECOUNT TRUE)
    endif()
endif()

# Set default build type to Release ##################################

if(NOT CMAKE_VERSION VERSION_LESS 3.9)
    get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
    set(isMultiConfig TRUE)
endif()

if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# primecount binary source files #####################################

set(BIN_SRC src/app/cmdoptions.cpp
            src/app/main.cpp
            src/app/help.cpp
            src/app/test.cpp)

# primecount library source files ####################################

set(LIB_SRC src/api.cpp
            src/api_c.cpp
            src/BitSieve240.cpp
            src/FactorTable.cpp
            src/RiemannR.cpp
            src/P2.cpp
            src/P3.cpp
            src/PhiTiny.cpp
            src/PiTable.cpp
            src/S1.cpp
            src/Sieve.cpp
            src/LoadBalancerP2.cpp
            src/LoadBalancerS2.cpp
            src/StatusS2.cpp
            src/generate.cpp
            src/nth_prime.cpp
            src/phi.cpp
            src/pi_legendre.cpp
            src/pi_lehmer.cpp
            src/pi_meissel.cpp
            src/pi_primesieve.cpp
            src/print.cpp
            src/util.cpp
            src/lmo/pi_lmo1.cpp
            src/lmo/pi_lmo2.cpp
            src/lmo/pi_lmo3.cpp
            src/lmo/pi_lmo4.cpp
            src/lmo/pi_lmo5.cpp
            src/lmo/pi_lmo_parallel.cpp
            src/deleglise-rivat/S2_hard.cpp
            src/deleglise-rivat/S2_trivial.cpp
            src/deleglise-rivat/pi_deleglise_rivat.cpp
            src/gourdon/pi_gourdon.cpp
            src/gourdon/Phi0.cpp
            src/gourdon/B.cpp
            src/gourdon/D.cpp
            src/gourdon/LoadBalancerAC.cpp
            src/gourdon/SegmentedPiTable.cpp
            src/gourdon/Sigma.cpp)

# Required includes ##################################################

include(GNUInstallDirs)

# Use -Wno-uninitialized with GCC compiler ###########################

# GCC's -Wuninitialized enabled with -Wall -pedantic causes
# false postive warnings in libprimecount:
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=107287
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(WNO_UNINITIALIZED "-Wno-uninitialized")
endif()

# libprimecount compile definitions ##################################

# Check at runtime if the dividend and divisor are < 2^32 and
# if so use 32-bit integer division instead of 64-bit integer
# division. On most CPUs before 2020 this significantly
# improves performance.
if(WITH_DIV32)
    set(ENABLE_DIV32 "ENABLE_DIV32")
endif()

# Enable expensive debugging assertions.
# These assertions enable e.g. bounds checks for the pod_vector
# and pod_array types.
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(ENABLE_ASSERT "ENABLE_ASSERT")
endif()

# Check if int128_t is supported #####################################

include("${PROJECT_SOURCE_DIR}/cmake/int128_t.cmake")

# Use libdivide.h (fast integer divison) #############################

if(WITH_LIBDIVIDE)
    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy_libdivide.cpp)
    set(LIB_SRC ${LIB_SRC} src/gourdon/AC_libdivide.cpp)
else()
    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy.cpp)
    set(LIB_SRC ${LIB_SRC} src/gourdon/AC.cpp)
endif()

# Enable __float128 support (requires libquadmath) ###################

if(WITH_FLOAT128)
    set(LIB_QUADMATH "quadmath")
    set_source_files_properties(src/RiemannR.cpp PROPERTIES COMPILE_DEFINITIONS HAVE_FLOAT128)
endif()

# Check for OpenMP ###################################################

if(WITH_OPENMP)
    include("${PROJECT_SOURCE_DIR}/cmake/OpenMP.cmake")
endif()

# Check if x86 CPU supports POPCNT instruction #######################

if(WITH_POPCNT)
    include("${PROJECT_SOURCE_DIR}/cmake/popcnt.cmake")
endif()

# libprimesieve ######################################################

# By default the libprimesieve dependency is built from source
# (BUILD_LIBPRIMESIEVE=ON). However when packaging primecount
# for e.g. a Linux distro this is not a good idea. For this use
# case it is better to install the libprimesieve package
# (e.g. libprimesieve-dev) and link against that version.

if(BUILD_LIBPRIMESIEVE)
    set(COPY_BUILD_MANPAGE "${BUILD_MANPAGE}")
    set(COPY_BUILD_TESTS "${BUILD_TESTS}")
    set(BUILD_MANPAGE OFF CACHE BOOL "Build primesieve manpage" FORCE)
    set(BUILD_TESTS OFF CACHE BOOL "Build primesieve tests" FORCE)
    option(BUILD_PRIMESIEVE "Build primesieve binary" OFF)

    add_subdirectory(lib/primesieve)

    if(BUILD_SHARED_LIBS)
        target_compile_options(libprimesieve PRIVATE "${POPCNT_FLAG}")
    endif()
    if(BUILD_STATIC_LIBS)
        target_compile_options(libprimesieve-static PRIVATE "${POPCNT_FLAG}")
    endif()

    set(BUILD_MANPAGE "${COPY_BUILD_MANPAGE}" CACHE BOOL "Regenerate man page using a2x" FORCE)
    set(BUILD_TESTS "${COPY_BUILD_TESTS}" CACHE BOOL "Build test programs" FORCE)
else()
    find_package(primesieve REQUIRED)

    if(primesieve_VERSION VERSION_LESS 11.0)
        message(FATAL_ERROR "Found libprimesive-${primesieve_VERSION}, but primecount requires libprimesive >= 11.0")
    endif()
endif()

# libprimecount ######################################################

if(BUILD_SHARED_LIBS)
    add_library(libprimecount SHARED ${LIB_SRC})
    set_target_properties(libprimecount PROPERTIES OUTPUT_NAME primecount)
    set_target_properties(libprimecount PROPERTIES SOVERSION ${PRIMECOUNT_VERSION_MAJOR})
    set_target_properties(libprimecount PROPERTIES VERSION ${PRIMECOUNT_VERSION})
    target_compile_options(libprimecount PRIVATE "${POPCNT_FLAG}" "${WNO_UNINITIALIZED}")
    target_compile_definitions(libprimecount PRIVATE "${DISABLE_INT128}" "${ENABLE_DIV32}" "${ENABLE_ASSERT}")
    target_link_libraries(libprimecount PRIVATE primesieve::primesieve "${LIB_OPENMP}" "${LIB_QUADMATH}" "${LIB_ATOMIC}")

    target_compile_features(libprimecount
    PRIVATE
        cxx_constexpr
        cxx_lambdas
        cxx_range_for)

    target_include_directories(libprimecount PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimecount
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# libprimecount-static ###############################################

if(BUILD_STATIC_LIBS)
    add_library(libprimecount-static STATIC ${LIB_SRC})
    set_target_properties(libprimecount-static PROPERTIES OUTPUT_NAME primecount)
    target_compile_options(libprimecount-static PRIVATE "${POPCNT_FLAG}" "${WNO_UNINITIALIZED}")
    target_compile_definitions(libprimecount-static PRIVATE "${DISABLE_INT128}" "${ENABLE_DIV32}" "${ENABLE_ASSERT}")
    target_link_libraries(libprimecount-static PRIVATE primesieve::primesieve "${LIB_OPENMP}" "${LIB_QUADMATH}" "${LIB_ATOMIC}")

    if(WITH_MSVC_CRT_STATIC)
        set_target_properties(libprimecount-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
    endif()

    target_compile_features(libprimecount-static
    PRIVATE
        cxx_constexpr
        cxx_lambdas
        cxx_range_for)

    target_include_directories(libprimecount-static PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimecount-static
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# Shared vs. static linking ##########################################

if(STATICALLY_LINK_LIBPRIMECOUNT)
    add_library(primecount::primecount ALIAS libprimecount-static)
else()
    add_library(primecount::primecount ALIAS libprimecount)
endif()

# primecount binary ##################################################

if(BUILD_PRIMECOUNT)
    add_executable(primecount ${BIN_SRC})
    target_link_libraries(primecount PRIVATE primecount::primecount primesieve::primesieve)
    target_compile_definitions(primecount PRIVATE "${DISABLE_INT128}" "${ENABLE_DIV32}" "${ENABLE_ASSERT}")
    target_compile_features(primecount PRIVATE cxx_auto_type)
    install(TARGETS primecount DESTINATION ${CMAKE_INSTALL_BINDIR})

    if(WITH_MSVC_CRT_STATIC)
        set_target_properties(primecount PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
    endif()
endif()

# Use jemalloc allocator #############################################

if(WITH_JEMALLOC)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(JEMALLOC jemalloc)
    pkg_search_module(JEMALLOC REQUIRED jemalloc)

    if(BUILD_PRIMECOUNT)
        target_link_libraries(primecount PRIVATE ${JEMALLOC_LIBRARIES})
        target_include_directories(primecount PRIVATE ${JEMALLOC_INCLUDE_DIRS})
    endif()
    if(BUILD_SHARED_LIBS)

=== debian/changelog ===
primecount (7.6+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/tests/control, capitalize coomands.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 15 Dec 2022 18:47:24 +0000

primecount (7.4+ds-2) unstable; urgency=medium

  * Debianization:
    - d/watch, update;
    - d/s/lintian-overrides, update.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 27 Nov 2022 15:51:21 +0000

=== debian/tests/control ===
--- 
+++ 
@@ -1,4 +1,4 @@
-Test-command: primecount --test
+Test-Command: primecount --test
 
 Tests: make-check-bin
 Depends: primecount-bin

## primecount 7.9+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.22)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 6)
+set(PRIMECOUNT_VERSION_MINOR 9)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -17,7 +17,7 @@
 option(WITH_LIBDIVIDE       "Use libdivide.h"                       ON)
 option(WITH_OPENMP          "Enable OpenMP multi-threading"         ON)
 option(WITH_MSVC_CRT_STATIC "Link primecount.lib with /MT instead of the default /MD" OFF)
-option(WITH_FLOAT128        "Use __float128 (requires libquadmath)" OFF)
+option(WITH_FLOAT128        "Use __float128 (requires libquadmath), increases precision of Li(x) & RiemannR" OFF)
 option(WITH_JEMALLOC        "Use jemalloc allocator"                OFF)
 
 # When using WITH_DIV32=ON primecount checks at runtime
@@ -199,8 +199,11 @@
 # (e.g. libprimesieve-dev) and link against that version.
 
 if(BUILD_LIBPRIMESIEVE)
+    set(COPY_BUILD_EXAMPLES "${BUILD_EXAMPLES}")
     set(COPY_BUILD_MANPAGE "${BUILD_MANPAGE}")
     set(COPY_BUILD_TESTS "${BUILD_TESTS}")
+
+    set(BUILD_EXAMPLES OFF CACHE BOOL "Build example programs" FORCE)
     set(BUILD_MANPAGE OFF CACHE BOOL "Build primesieve manpage" FORCE)
     set(BUILD_TESTS OFF CACHE BOOL "Build primesieve tests" FORCE)
     option(BUILD_PRIMESIEVE "Build primesieve binary" OFF)
@@ -214,6 +217,7 @@
         target_compile_options(libprimesieve-static PRIVATE "${POPCNT_FLAG}")
     endif()
 
+    set(BUILD_EXAMPLES "${COPY_BUILD_EXAMPLES}" CACHE BOOL "Build example programs" FORCE)
     set(BUILD_MANPAGE "${COPY_BUILD_MANPAGE}" CACHE BOOL "Regenerate man page using a2x" FORCE)
     set(BUILD_TESTS "${COPY_BUILD_TESTS}" CACHE BOOL "Build test programs" FORCE)
 else()
@@ -307,10 +311,3 @@
 if(WITH_JEMALLOC)
     find_package(PkgConfig REQUIRED)
     pkg_check_modules(JEMALLOC jemalloc)
-    pkg_search_module(JEMALLOC REQUIRED jemalloc)
-
-    if(BUILD_PRIMECOUNT)
-        target_link_libraries(primecount PRIVATE ${JEMALLOC_LIBRARIES})
-        target_include_directories(primecount PRIVATE ${JEMALLOC_INCLUDE_DIRS})
-    endif()
-    if(BUILD_SHARED_LIBS)

=== debian/changelog ===
primecount (7.9+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - copyright year-tuples, update;
    - d/control:
      - Standards-Version, bump to 4.6.2 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 17 Jul 2023 09:24:29 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  asciidoc-base, xmlto
 Build-Depends-Indep:
 	pandoc
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/math-team/primecount.git
 Vcs-Browser: https://salsa.debian.org/math-team/primecount
 Homepage: https://github.com/kimwalisch/primecount

## primecount 7.10%2Bds

=== debian/changelog ===
primecount (7.10+ds-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:49:11 +0000

primecount (7.10+ds-1build1) noble; urgency=medium

  * No-change rebuild against libprimesieve12

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2024 07:35:02 +0000

primecount (7.10+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - copyright year-tuples, update.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 25 Jan 2024 17:04:37 +0000

## primecount 7.10+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 3.4...3.22)
+cmake_minimum_required(VERSION 3.4...3.27)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 9)
+set(PRIMECOUNT_VERSION_MINOR 10)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -151,8 +151,8 @@
 endif()
 
 # Enable expensive debugging assertions.
-# These assertions enable e.g. bounds checks for the pod_vector
-# and pod_array types.
+# These assertions enable e.g. bounds checks
+# for the Vector and Array types.
 if(CMAKE_BUILD_TYPE STREQUAL "Debug")
     set(ENABLE_ASSERT "ENABLE_ASSERT")
 endif()

=== test/CMakeLists.txt ===
file(GLOB files "*.cpp")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_compile_definitions(${binary_name} PRIVATE "${DISABLE_INT128}" "${ENABLE_DIV32}" "${ENABLE_ASSERT}")
    target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve "${LIB_OPENMP}" "${LIB_ATOMIC}")
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

# The order here is important, we want simpler implementations
# to be tested before more advanced/complex implementations.
# LMO is less complex than deleglise-rivat, deleglise-rivat is
# less complex than gourdon, and the C/C++ API depends on all
# these implementations.
add_subdirectory(lmo)
add_subdirectory(deleglise-rivat)
add_subdirectory(gourdon)
add_subdirectory(api)

=== test/api/CMakeLists.txt ===
enable_language(C)
file(GLOB files "*.cpp" "*.c")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_compile_definitions(${binary_name} PRIVATE "${DISABLE_INT128}" "${ENABLE_DIV32}" "${ENABLE_ASSERT}")
    target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve "${LIB_OPENMP}" "${LIB_ATOMIC}")
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

=== test/deleglise-rivat/CMakeLists.txt ===
file(GLOB files "*.cpp")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_compile_definitions(${binary_name} PRIVATE "${DISABLE_INT128}" "${ENABLE_DIV32}" "${ENABLE_ASSERT}")
    target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve "${LIB_OPENMP}" "${LIB_ATOMIC}")
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: primecount
-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional

## primecount 7.13+ds

=== debian/changelog ===
primecount (7.13+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/control:
      - Standards-Version, bump to 4.7.0 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 21 Apr 2024 13:03:33 +0000

primecount (7.12+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-source-infinite_loops_on_i386.patch, obsoleted.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 05 Apr 2024 15:26:06 +0000

primecount (7.11+ds-2) unstable; urgency=medium

  * FTBFS on i386 arch fix release.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-source-infinite_loops_on_i386.patch, import
        from upstream repositiry.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 22 Mar 2024 16:39:41 +0000

primecount (7.11+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - Files-Excluded list, refresh;
    - d{,/t}/control, rename pkg-config pkgconf.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 15 Mar 2024 13:00:06 +0000

## primecount 7.14%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: primecount
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
@@ -12,7 +11,7 @@
  asciidoc-base, xmlto
 Build-Depends-Indep:
 	pandoc
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/math-team/primecount.git
 Vcs-Browser: https://salsa.debian.org/math-team/primecount
 Homepage: https://github.com/kimwalisch/primecount
@@ -56,7 +55,7 @@
  libprimecount7 (= ${binary:Version}), libprimecount-dev-common (= ${source:Version}),
  libprimesieve-dev,
  ${misc:Depends}
-Suggests: primecount-doc (= ${source:Version}), pkg-config
+Suggests: primecount-doc (= ${source:Version}), pkgconf
 Conflicts: libprimecount-dev
 Provides: libprimecount-dev
 Description: fast prime number counter C/C++ library -- libdev

=== debian/tests/control ===
Test-Command: primecount --test

Tests: make-check-bin
Depends: primecount-bin

Tests: make-check-dev
Depends: libprimecount-dev, build-essential, pkgconf
Restrictions: allow-stderr

Tests: build-examples
Depends: primecount-doc, libprimecount-dev, build-essential, pkgconf
